# Demucs API

> موسیقی کے ٹریک کو گائیکی، ڈھول، باس، گٹار اور پیانو جیسے الگ تنے میں تقسیم کرتا ہے، جن کے ویرینٹس منتخب کیے جا سکتے ہیں

گانے کو انفرادی سازوں کے ٹریکس میں الگ کرتا ہے۔ `model` کے ذریعے Demucs ویرینٹ منتخب کریں (ڈیفالٹ htdemucs_6s، جو گٹار اور پیانو بھی فراہم کرتا ہے)، `stems` سے آؤٹ پٹ محدود کریں، اور `shifts` (1 سے 10)، `overlap` (0 سے 1) اور `segment_length` سے معیار ایڈجسٹ کریں۔ تنے بطور mp3 یا wav فائلیں، ہر ماخذ کے لیے ایک، واپس کیے جاتے ہیں۔

- Model id: `demucs`
- Made by: Meta
- Category: Audio
- Output: json
- Price per second of your input audio: $0.0007 / second of input audio (cheapest run $0.001 (1 API credit))
- Run: `POST https://api.doitong.com/v1/run/demucs`
- Quote: `POST https://api.doitong.com/v1/quote/demucs`
- Docs page: https://doitong.com/ur/developers/models/demucs

## Pricing

Price: **$0.0007 / second of input audio**. Price per second of your input audio: the input files are measured before the run (length, resolution, frame rate). The quote measures the same files and is exactly what the run charges.

The full example input below costs $0.007 = 7 API credits (10 s input audio × $0.0007).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.com/v1/quote/demucs` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `audio_url` | `audio` | string (audio URL) | yes |  |  | اسٹیم علیحدگی کے لیے آڈیو فائل کی طرف اشارہ کرنے والا URL۔ |
| `model` |  | enum (string) | no | `htdemucs_6s` | `htdemucs`, `htdemucs_ft`, `htdemucs_6s`, `hdemucs_mmi`, `mdx`, `mdx_extra`, `mdx_q`, `mdx_extra_q` | اسٹیم علیحدگی کے لیے منتخب کردہ Demucs ماڈل۔ |
| `stems` |  | array of enum (string) \| null | no | `["vocals","drums","bass","other","guitar","piano"]` |  | ماڈل کے دستیاب اختیارات میں سے اسٹیم کا انتخاب: vocals، drums، bass، other، guitar، piano (6s ماڈل کے لیے)۔ کسی مخصوص انتخاب کے بجائے ماڈل کے پیش کردہ تمام اسٹیم نکالنے کے لیے None سیٹ کریں۔ |
| `segment_length` |  | integer \| null | no |  | ≥ 1 | پروسیسنگ سیگمنٹ کا دورانیہ سیکنڈ میں، ماڈل کے لحاظ سے ڈیفالٹ کے ساتھ۔ اسے کم کرنے سے میموری کا استعمال کم ہوتا ہے، لیکن معیار متاثر ہو سکتا ہے؛ کم از کم قدر 1 ہے۔ |
| `shifts` |  | integer | no | `1` | 1 – 10 | Equivariant stabilization کے لیے random-shift کی تعداد؛ تعداد بڑھانے سے اضافی پروسیسنگ وقت کے عوض معیار بہتر ہوتا ہے۔ |
| `overlap` |  | number | no | `0.25` | 0 – 1 | سیگمنٹ اوورلیپ؛ اسے بڑھانے سے پروسیسنگ کا وقت بڑھتا ہے اور معیار بہتر ہو سکتا ہے؛ معاون حد 0.0–1.0 ہے۔ |
| `output_format` |  | enum (string) | no | `mp3` | `wav`, `mp3` | علیحدہ کیے گئے اسٹیم محفوظ کرنے کے لیے آڈیو فارمیٹ۔ |

File parameters (`audio`) take a public `https://` URL, a `data:` URI up to 10 MB, or the `file_url` of an upload from `POST /files`.

## Example input

Required parameters only:

```json
{
  "audio": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
}
```

A fuller example:

```json
{
  "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.com/v1/run/demucs?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.com/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.com/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/demucs?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.com/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/demucs", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.com/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "demucs",
      "input": {
        "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "demucs",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 7,
    "usd": "0.007",
    "charged": 7,
    "refunded": 0
  },
  "input": {
    "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
  },
  "output": {
    "vocals": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200
    },
    "drums": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200
    },
    "bass": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200
    },
    "other": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200
    },
    "guitar": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200
    },
    "piano": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200
    }
  },
  "outputs": [
    {
      "type": "file",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `vocals` | object {url, content_type, file_name, file_size} \| null | الگ کیے گئے vocals پر مشتمل آڈیو فائل۔ |
| `drums` | object {url, content_type, file_name, file_size} \| null | الگ کیے گئے drums پر مشتمل آڈیو فائل۔ |
| `bass` | object {url, content_type, file_name, file_size} \| null | الگ کیے گئے bass پر مشتمل آڈیو فائل۔ |
| `other` | object {url, content_type, file_name, file_size} \| null | الگ کیے گئے دیگر سازوں پر مشتمل آڈیو فائل۔ |
| `guitar` | object {url, content_type, file_name, file_size} \| null | الگ کیے گئے guitar پر مشتمل آڈیو فائل، صرف 6s ماڈلز کے ساتھ دستیاب ہے۔ |
| `piano` | object {url, content_type, file_name, file_size} \| null | الگ کیے گئے piano پر مشتمل آڈیو فائل، صرف 6s ماڈلز کے ساتھ دستیاب ہے۔ |

## Related models

- [MMAudio V2](https://doitong.com/developers/models/mmaudio-v2.md) (`mmaudio-v2`): $0.001 / second
- [Sam Audio · Separate](https://doitong.com/developers/models/sam-audio/separate.md) (`sam-audio/separate`): from $0.05 / 30 seconds of input audio
- [Sam Audio · Span Separate](https://doitong.com/developers/models/sam-audio/span-separate.md) (`sam-audio/span-separate`): from $0.05 / 30 seconds of input audio
- [DeepFilterNet 3](https://doitong.com/developers/models/deepfilternet3.md) (`deepfilternet3`): $0.001 / second of input audio
- [ElevenLabs Audio Isolation](https://doitong.com/developers/models/elevenlabs/audio-isolation.md) (`elevenlabs/audio-isolation`): $0.10 / minute of input file
- [Elevenlabs Sound Effects V2](https://doitong.com/developers/models/elevenlabs/sound-effects/v2.md) (`elevenlabs/sound-effects/v2`): $0.002 / second
- [ElevenLabs Voice Changer](https://doitong.com/developers/models/elevenlabs/voice-changer.md) (`elevenlabs/voice-changer`): $0.30 / minute of input audio
- [FFmpeg API \[Merge Audios\]](https://doitong.com/developers/models/ffmpeg-api/merge-audios.md) (`ffmpeg-api/merge-audios`): $0.00017 / second of processing time

## Links

- HTML page: https://doitong.com/developers/models/demucs
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=demucs
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.com/v1/models/demucs
